#ifndef F4_GPIO_HEADER
#define F4_GPIO_HEADER

#include <stdint.h>

#include "brd.h"

#define GPIO_NUOF_DEVICES 9

struct gpio_device {
  GPIO_TypeDef *gpio;
  //uint32_t rcc_ahb1;
};

extern const struct gpio_device gpio_devices[GPIO_NUOF_DEVICES];


/* Process pin name */
extern int f4_gpio_devnr_of(char *pin_name);
extern int f4_gpio_pinmask_of(char *pin_name);
extern int f4_gpio_pinnr_of(char *pin_name);


/* Bit initialization */
// Mode   Otype   Speed           PuPd
// [IOFA] [P[OD]] [[L2]M[F5][H1]] [NUD]
extern int f4_gpio_pin_init_of(char *pin_name, char *init);
extern int f4_gpio_input(char *pin_name);
extern int f4_gpio_output(char *pin_name);
extern int f4_gpio_soutput(char *pin_name, int init_value);
extern int f4_gpio_analog(char *pin_name);
extern int f4_gpio_af(char *pin_name, uint8_t af);
extern int f4_gpio_init_af(char *pin_name, char *init, uint8_t af);
extern int f4_gpio_exti(char *pin_name, int edge, int af);


/* Set/get bit */
extern int f4_gpio_set(char *pin_name, int value);
extern int f4_gpio_inv(char *pin_name);
extern int f4_gpio_get(char *pin_name);
extern int f4_gpio_oget(char *pin_name);

/* Bit banding */
extern uint32_t *f4_gpio_band_output(char *pin_name);
extern uint32_t *f4_gpio_band_input(char *pin_name);

extern uint16_t *f4_gpio_odr(char *pin_name);
extern GPIO_TypeDef *f4_gpio_of(char *pin_name);
extern char *f4_gpio_name(GPIO_TypeDef *port);

/* Print info */
extern void f4_print_gpio(int fd, char *pin_name);


#endif
